import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Base64;
import java.util.Date;
import java.util.Random;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Entity;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.Form;
import javax.ws.rs.core.MediaType;
import javax.xml.bind.DatatypeConverter;

public class RestMarketext {
    private static final String CHAR_LIST = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";
    private static final int RANDOM_STRING_LENGTH = 32;
    private static String host = "restapi.marketext.com";        // Especificar el host
    private static String port = "443";        // Especificar el puerto
     
	public static void main(String[] args) {
		String api_id = "api_id";
        String user = "user_id";
        String password = "password";
        String to = "573001234567";
		String text = "Prueba de envio de mensajes Marketext REST"; 
		String smstype = "y";
		String msg_id = "75e399dbd6ede5128c0a063c7a6c3fbc";
		
		/* Para enviar mensajes */
		// sendSMS(api_id, user, password, to, text,smstype);
		
		/* Para consultar el estado de un mensaje / los estados se empiezan a ver reflejados aproximadamwente 2 minutos despus de haber sido enviados. */
		// querySMS(api_id, user, msg_id);
	}

	public static void sendSMS(String api_id, String user, String password, String to, String text) {
		sendSMS(api_id, user,  password, to, text, "y", "", "");
	}

	public static void sendSMS(String api_id, String user, String password, String to, String text, String smstype) {
		sendSMS(api_id, user,  password, to, text, smstype, "", "");
	}
	
	public static void sendSMS(String api_id, String user, String password, String to, String text, String smstype, String date_delivery, String time_delivery) {
	    Long lts = new Date().getTime();
	    String ts = lts.toString();
	    
        String nonce = generateRandomString();
        String method = "POST";        // Definir el mtodo de la solicitud
        String URI = "/sms/" + api_id;	// Especificar la URI
        String mac = ts + "\n" + 	// Preparar la cadena base
             nonce + "\n" +
             method + "\n" +
             URI + "\n" +
             host + "\n" +
             port + "\n" +
             "\n";

		try {
	        MessageDigest md;
			md = MessageDigest.getInstance("MD5");
	        md.update(password.getBytes());
	        byte[] md5digest = md.digest();
	        String md5Pass = DatatypeConverter.printHexBinary(md5digest).toLowerCase();
	        
	        String hash_hmac = hash_hmac(mac, md5Pass);
            
			String cod = "MAC id=\"" + user + "\",ts=\"" + ts + "\", nonce=\"" + nonce + "\", mac=\"" + hash_hmac + "\"";

			Client client = ClientBuilder.newClient();
			WebTarget target= client.target("https://" + host + ":" + port + URI);
			
			// Generar un formulario con los parmetros de envo
			Form form = new Form();
			form.param("destination", to);
			form.param("text", text);
			form.param("smstype", smstype);
			form.param("date_delivery", date_delivery);
			form.param("time_delivery", time_delivery);
			form.param("format", "application/json");
			 
			// Hacer la solicitud y almacenar la respuesta en smsResponse
			smsResponse bean =
			target.request(MediaType.APPLICATION_JSON_TYPE).
				header("Authorization", cod).
			    post(Entity.entity(form,MediaType.APPLICATION_FORM_URLENCODED_TYPE), smsResponse.class);
			
			System.out.println("Number: " + bean.Number + " - MsgID: " + bean.MsgID);
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
             
	}
	
	public static void querySMS(String api_id, String user_id, String msg_id) {
		try {
			String URI = "/sms/" + api_id + "/" + user_id + "/" + msg_id;
			Client client = ClientBuilder.newClient();
			System.out.println("https://" + host + ":" + port + URI);
			WebTarget target= client.target("https://" + host + ":" + port + URI);
			queryResponse bean =
					target.request().get(queryResponse.class);
			System.out.println("Status: " + bean.status);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

    public static String hash_hmac(String plain, String secretKey) {
        byte[] keyBytes = secretKey.getBytes();
        byte[] plainBytes = plain.getBytes();
        try {
            Mac sha256_HMAC = Mac.getInstance("HmacSHA256");
            SecretKeySpec secret_key = new SecretKeySpec(keyBytes, "HmacSHA256");
            sha256_HMAC.init(secret_key);
            byte[] hashs = sha256_HMAC.doFinal(plainBytes);
			return Base64.getEncoder().encodeToString(hashs);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
    
    public static String generateRandomString(){
        
        StringBuffer randStr = new StringBuffer();
        for(int i=0; i<RANDOM_STRING_LENGTH; i++){
            int number = getRandomNumber();
            char ch = CHAR_LIST.charAt(number);
            randStr.append(ch);
        }
        return randStr.toString();
    }
     
    private static int getRandomNumber() {
        int randomInt = 0;
        Random randomGenerator = new Random();
        randomInt = randomGenerator.nextInt(CHAR_LIST.length());
        if (randomInt - 1 == -1) {
            return randomInt;
        } else {
            return randomInt - 1;
        }
    }
    
}
